<?

/*

**************************************************************************

           TPLN v.1.0  by HAYOUN Laurent

           website: http://tpln.sourceforge.net
           email: php_work@hotmail.com

***************************************************************************


Licence et conditions d'utilisations-----------------------------------------------------------------------------

-English---------------------------------------------------------------------------------------------------------
Copyright (C) 2002  - AUTHOR : Hayoun Laurent


This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General
Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option)
any later version.

This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
details.

You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to :

Free Software Foundation,
Inc., 59 Temple Place,
Suite 330, Boston,
MA 02111-1307, Etats-Unis.
------------------------------------------------------------------------------------------------------------------

-Franais---------------------------------------------------------------------------------------------------------
TPLN est distribu sous licence LGPL, merci de laisser cette en-tte, gage et garantie de cette licence.
TPLN est un moteur de template destin  tre utilis par des applications crites en PHP.
TPLN peut tre utilis dans des scripts vendus  des tiers aux titres de la licence LGPL. TPLN n'en reste
pas moins OpenSource et libre de droits en date du 23 Aot 2001.

Copyright (C) 2002  - AUTHOR : Hayoun Laurent

Cette bibliothque est libre, vous pouvez la redistribuer et/ou la modifier selon les termes de la Licence Publique
Gnrale GNU Limite publie par la Free Software Foundation version 2.1 et ultrieure.

Cette bibliothque est distribue car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la Licence
Publique Gnrale GNU Limite pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU Limite en mme temps que cette bibliothque;
si ce n'est pas le cas, crivez :

Free Software Foundation,
Inc., 59 Temple Place,
Suite 330, Boston,
MA 02111-1307, Etats-Unis.

Pour tout renseignements mailez  php_work@hotmail.com
--------------------------------------------------------------------------------------------------------------------
*/


//Initialisation de l'include_path
$old_path = ini_get('include_path');
$os = ((stristr(getenv('SERVER_SOFTWARE'), 'win') || stristr(getenv('SERVER_SOFTWARE'), 'microsoft'))? ';' : ':');
$path = $os.ini_get('include_path');
ini_set('include_path', $path);

//Inclusion du fichier de configuration et de Db
require_once('TPLN_Cfg.php');
require_once('TPLN_DB.php');

// on remet l'include path au fichier appellant
ini_set('include_path', $old_path);


class TPLN extends DB
{
 var $file; // nom de tous les fichier

 var $add_cached_file = 0; // gestion du cache
 var $is_cached = 0; // gestion du cache
 var $time_started;
 var $cache_expire;

 var $filebuffer; // structure du fichier
 var $all_item_def = array(); // capture de tous les items du fichier
 var $all_bloc_def = array(); // capture de tous les noms de blocs
 var $bloc = array(); // capture les blocs (structure,items,parsed)

 var $bloc_loop = array(); //stocke les bloc loop
 var $last_bloc_path; // retiens le chemin du dernier bloc
 var $end_bloc_tmp = array(); // retiens les bloc avant leur sortie

// chrono
 var $add_chrono=0; // doit t-on ajout le chrono ?
 var $execution_time;
 var $chrono_started;
 var $chrono_type; // on veut le chrono de qui ?

// logo
 var $add_logo=0; // ajout du logo


// ouvre un fichier et le place en mmoire
// gestion des erreurs 0 fichier non trouv
 function Open($file,$cached="",$cached_time="")
 {
  $this->file = $file;

  $time = explode(' ',microtime());
  $this->time_started = time(); // dans pour le cache  la seconde
  $this->chrono_started = $time[1] + $time[0];

  if(!defined(TPLN_CHRONO_STARTED)){define("TPLN_CHRONO_STARTED",$this->chrono_started);}

   // on regarde si le fichier est en cache
   if(!empty($cached))
    {
      // le repertoire existe ?
      if(!is_dir(TPLN_CACHE_DIR))
       {
        mkdir(TPLN_CACHE_DIR,0755);
        clearstatcache();
       }

      if(empty($cached_time)){$cached_time = TPLN_CACHE_TIME;}
      $this->cache_expire = $this->time_started+$cached_time; // cache d'expiration

      // on regarde le fichier est encore en cache
      // fichier existe && sa date de creation est <= au temps de cache
      if(file_exists(TPLN_CACHE_DIR."$this->file") && $this->_InCachePeriod(TPLN_CACHE_DIR."$this->file"))
       {
        $this->add_cached_file = 0;

        $fp = @fopen(TPLN_CACHE_DIR."$this->file", "r");
        $tmp_expire = fgets($fp,12); // pour la position du pointeur apres le temps
        $this->filebuffer = @fread($fp,filesize(TPLN_CACHE_DIR."$this->file"));
        @fclose($fp);
        clearstatcache(); // efface la mmoire tampon

        return true;
       }
      else
       { $this->add_cached_file = 1; }
    }



   if(!$fp = @fopen($this->file, "r")) // ouverture du fichier
     {$this->_Error(0,$this->file);}

      $this->filebuffer = @fread($fp,filesize($this->file));
      @fclose($fp);
      clearstatcache(); // efface la mmoire tampon

     $this->all_item_def = $this->_CaptureItem();

     if($this->add_cached_file == 1){ return 0;}
 }

// loop pour savoir si le bloc doit tre en loop ou pas ?
 function Loop($path="")
 {
  if(empty($path) || ($path == "this"))
    {$path = $this->last_bloc_path;}

 $all_bloc = @explode(".",$path);
 $last_bloc_name = $all_bloc[@count($all_bloc)-1];

 // on atteint le bloc
 $ref = &$this->bloc;

 // prend le chemin et la structure des pres du bloc
 for($i=0;$i<@count($all_bloc)-1;$i++)
  {$ref = &$ref[$all_bloc[$i]]["children"];}

 // initialisation
 if(!@in_array($path,$this->bloc_loop))
   {
    $this->bloc_loop[] = $path;
   }
  else
   {
    $ref["$last_bloc_name"]["parsed"] .= $this->bloc_loop["$path"]["parsed"]; // assignation de la structure
   }

   $this->bloc_loop["$path"]["parsed"] = $ref["$last_bloc_name"]["structure"];     // initialisation de la structure

 }


// parsing
 function Parse($item,$replace,$functions="")
 {
   if(@preg_match("/[.]/",$item)) // est ce un bloc que utilisateur appelle?
    {
      $in_bloc = 1; // dans un bloc
      $bloc = $this->_Bloc($item); // on s'occupe du bloc & retourne le bloc et l'item

      $item =  $bloc["item"];
      $path =  $bloc["path"];
      $all_bloc = $bloc["all_bloc"];
      $bloc_name =  $bloc["bloc_name"];
   }

  // vrification de la prsence de l'item
  if(!@in_array($item,$this->all_item_def)){$this->_Error(1,$item);}

  // fonction de formatage des donnes
  $replace = $this->_ApplySpecialFunction($replace,$functions);


  if($in_bloc == 1) // parsing dans un bloc
    {
      $ref = &$this->bloc;

     // prend le chemin et la structure
     // des peres du bloc
     for($i=0;$i<@count($all_bloc)-1;$i++)
      {$ref = &$ref[$all_bloc[$i]]["children"];}

     // remplacement dans un bloc normal
     if(!@in_array($path,$this->bloc_loop))
      {
       $structure = $ref["$bloc_name"]["parsed"];
       $tmp_replace = $this->_ReplaceItem($item,$replace,$structure);
       $ref["$bloc_name"]["parsed"] = $tmp_replace;
      }
     else
      {
       // bloc loop
       $structure = $this->bloc_loop["$path"]["parsed"];
       $tmp_replace = $this->_ReplaceItem($item,$replace,$structure);
       $this->bloc_loop["$path"]["parsed"] = $tmp_replace;
      }

    }
  else
    {
     $this->filebuffer = $this->_ReplaceItem($item,$replace,$this->filebuffer);
    }
 }

// pour les fonctions spciales
function _ApplySpecialFunction($replace="", $functions="")
{
 if(empty($functions))   // pas de fonction spciale
  {return $replace;}

   // y a t'il une fonction spciale ?
    $functions = @explode("|",$functions);

    foreach($functions as $function_name)
     {
       if($function_name != "B" && $function_name != "I" && $function_name != "U" && !empty($function_name))
        {$replace = $function_name("$replace");}
     }

    // Bold, Italic, Underline
    if(@in_array("B",$functions)){$replace = "<b>$replace</b>";}
    if(@in_array("I",$functions)){$replace = "<i>$replace</i>";}
    if(@in_array("U",$functions)){$replace = "<u>$replace</u>";}


 return $replace;
}

 // effacement d'un item
 function EraseItem($item)
 {
   $this->Parse($item,"");
 }



 // effacement d'un bloc
 function EraseBloc($path)
 {
    // vrification de l'existance des bloc
  //  et assignation en cas de ngativit
  $all_bloc = @explode(".",$path);
  $bloc_name = $all_bloc[@count($all_bloc)-1];

    for($i=0;$i<@count($all_bloc);$i++)
    {
      $i == 0 ? $tmp_path = $all_bloc[$i] : $tmp_path .= ".".$all_bloc[$i];
      $bloc = $this->_Bloc($tmp_path,SHORT);
    }


   $all_bloc = $bloc["all_bloc"];
   $bloc_name =  $bloc["bloc_name"];

   // big father
   if(@count($all_bloc) == 1)
    {
     $this->filebuffer = $this->_ReplaceBloc($bloc_name,"",$this->filebuffer);
     unset($this->bloc["$bloc_name"]); // effacement dans les bloc definis
    }
   else
    {
       $ref = &$this->bloc;

         for($i=0;$i<@count($all_bloc)-1;$i++)
          {
           $ref = &$ref[$all_bloc[$i]]["children"];
          }

        $ref["$bloc_name"]["parsed"] = "";
    }

 }

 // sortie d'un bloc
 function GetBlocInFile($path)
 {
   $all_bloc = @explode(".",$path);
   $bloc_name =  $all_bloc[@count($all_bloc)-1];

   $bloc = $this->_CaptureBloc($bloc_name,$this->filebuffer);
   return $bloc;
 }

 // remplacement d'un bloc entier
 function ParseBloc($path,$replace)
 {
  // vrification de l'existance des bloc
  $all_bloc = @explode(".",$path);
  //  et assignation en cas de ngativit
    for($i=0;$i<@count($all_bloc);$i++)
    {
      $i == 0 ? $tmp_path = $all_bloc[$i] : $tmp_path .= ".".$all_bloc[$i];
      $bloc = $this->_Bloc($tmp_path,SHORT);
    }

    $all_bloc = $bloc["all_bloc"];
    $bloc_name = $bloc["bloc_name"];

   // on remplace le bloc par son remplacant dans son pere
   $ref = &$this->bloc;

   for($i=0;$i<@count($all_bloc)-1;$i++)
     {$ref = &$ref[$all_bloc[$i]]["children"];}

    $ref["$bloc_name"]["parsed"] = $replace;

 }


// private function
// retourne item  parser et le chemin pour arriver au bloc
// type LONG pour un parsing normal
// SHORT pour effacement d'un bloc
 function _Bloc($total_item,$type="LONG")     // verification du bloc et retourne l'item
 {
    $all_bloc_path = @explode(".",$total_item); // on scinde en tableau

    if($type == "LONG")
    {
     $item = $all_bloc_path[@count($all_bloc_path)-1]; // item dernier lment du tableau
     $all_bloc_path = @array_slice($all_bloc_path,0,@count($all_bloc_path)-1);// suppression de l'item du tableau dernier lment
    }

    $path = @join(".",$all_bloc_path);
    $fathers_path = @array_slice($all_bloc_path,0,@count($all_bloc_path)-1); // tous les noms sauf le dernier
    $last_bloc = $all_bloc_path[@count($all_bloc_path)-1];


    $this->last_bloc_path = @join($all_bloc_path,".");

    // si un bloc est appel ses peres sont dja dfinis
    // verification de la dfinition des peres
    for($i=0;$i<@count($fathers_path);$i++)
    {
      if(!@in_array($fathers_path[$i],$this->all_bloc_def))
       {$this->_Error(4,@join($all_bloc_path,"."));}
    }

     // definition du dernier bloc si non dfini
    if(!@in_array($last_bloc,$this->all_bloc_def))
    {
      // Big father ou pas
      if(@count($fathers_path) == 0)
        {
         $this->_BlocDefine($last_bloc,father);
        }
      else
        {
          $bloc_construct = $this->_BlocDefine($last_bloc,children); // definition
          $this->_SaveChildrenBloc($bloc_construct,$last_bloc,$fathers_path); // encapsulation
        }
    }

  if($type == "LONG") // utile pour un parsing normal
   {$bloc["item"] = $item;}

  $bloc["path"] = $path;
  $bloc["all_bloc"] = $all_bloc_path;
  $bloc["bloc_name"] = $last_bloc;

  return $bloc;
 }

 // definition d'un bloc
 function _BlocDefine($bloc_name,$type)
 {
  // analyse du bloc pere s la source
  // les fils sont chez le pere ;-)
  $struct_blc = $this->_CaptureBloc($bloc_name,$this->filebuffer);// capture du bloc

   // $match
   if($type == "father")
     {
          // definition du bloc pere direct
          $this->bloc["$bloc_name"]["structure"] = $struct_blc; // structure total du pre
          $this->bloc["$bloc_name"]["parsed"] = $struct_blc; // parsed
     }
   // enfant
   if($type == "children")
     {
      $tmp_arr["structure"] = $struct_blc;
      $tmp_arr["parsed"] = $struct_blc;
     }

   $this->all_bloc_def[] = $bloc_name;   // sauvegarde

   return $tmp_arr;   // retourne le bloc array
 }


// encapsulation d'un enfant
// le pere est considr comme dfini
 function _SaveChildrenBloc($bloc,$bloc_name,$fathers)
 {
     $ref = &$this->bloc;

     // prend le chemin et la structure des peres du bloc
     for($i=0;$i<@count($fathers);$i++)
     {
       $ref = &$ref[$fathers[$i]]["children"];
     }

     // encapsulation chez son pere
     $ref["$bloc_name"] = $bloc;
 }

// fonction capture item
 function _CaptureItem($subject="")
 {
   if(empty($subject))
    {$subject = $this->filebuffer;} // ds le fichier
   else
    {
     $subject = $this->GetBlocInFile($subject);
    }

   $motif = "/\{(.*)?\}/msU";
   $match = @preg_match_all($motif,$subject,$tab);

   // on ddoublonne le tableau
   $get_item = $tab[1];
   $only_one = @array_unique($get_item);

   foreach($only_one as $item)
    {$tmp_item[] = $item;}

   return $tmp_item;
 }

// fonction qui capture un bloc sans ses motif
 function _CaptureBloc($name,$subject)
 {
   if(empty($name)){$this->_Error(5);}

   $motif = "<$name>(.*)?<\\/$name>";
   $match = @preg_match("/$motif/msU",$subject,$bloc);

   // error
   if(!$match) {$this->_Error(2,'',$name);}

  return $bloc[1];
 }

// item replace
 function _ReplaceItem($name,$replace,$subject)
 {
   if(empty($name)){$this->_Error(6);}

   $str = @preg_replace("/\{$name\}/U",$replace,$subject);
   return $str;
 }

// fonction qui replace un bloc sans ses motif
 function _ReplaceBloc($name,$replace,$subject)
 {

  if(empty($name)){$this->_Error(5);}

   // c'est pas un tableau
   if(!is_array($name) && !is_array($replace))
    {
     $motif = "<$name>(.*)?<\\/$name>";
     $str = @preg_replace("/$motif/msU",$replace,$subject);
    }
    else
    {
     $str = @preg_replace($name,$replace,$subject);
    }
   return $str;
 }

 // 2 array pour un remplacement direct
 function _ArrayParse($item, $replace, $path="")
 {
   // vrification de l'existance des bloc
   //  et assignation en cas de ngativit
   $all_bloc = @explode(".",$path);
   $bloc_name = $all_bloc[@count($all_bloc)-1];

   for($i=0;$i<@count($all_bloc);$i++)
    {
     $i == 0 ? $tmp_path = $all_bloc[$i] : $tmp_path .= ".".$all_bloc[$i];
     $bloc = $this->_Bloc($tmp_path,SHORT);
     }

     $all_bloc = $bloc["all_bloc"];
     $bloc_name =  $bloc["bloc_name"];

     // on prend le bloc & hop on place
     $ref = &$this->bloc;

     for($i=0;$i<@count($all_bloc)-1;$i++)
       {$ref = &$ref[$all_bloc[$i]]["children"];}

      //$ref["$bloc_name"]["parsed"] .= @preg_replace($item,$replace,$ref["$bloc_name"]["structure"]);

      // remplacement dans un bloc normal
     if(!@in_array($path,$this->bloc_loop))
      {
       $structure = $ref["$bloc_name"]["parsed"];
       $tmp_replace = @preg_replace($item,$replace,$structure);
       $ref["$bloc_name"]["parsed"] = $tmp_replace;
      }
     else
      {
       // bloc loop
       $structure = $this->bloc_loop["$path"]["parsed"];
       $tmp_replace = @preg_replace($item,$replace,$structure);
       $this->bloc_loop["$path"]["parsed"] = $tmp_replace;
      }

 }



// criture des bloc avant une sortie !
 function _AllWriteBloc($id_bloc=-1,$level=0,$arr="",$bloc_name="")
 {
   if(empty($arr)) {$arr = &$this->bloc;} // initialisation

   $keys = @array_keys($arr); // les clefs ou blocs

   // pour chaque bloc y a til un fils
   for($i=0;$i<@count($keys);$i++)
   {

   $cur_bloc_name = $keys[$i];
   $bloc_parsed = $arr[$cur_bloc_name]["parsed"];


     if($level == 0)
       {
        $id_bloc++;

        $this->end_bloc_tmp[$id_bloc]["name"] = $cur_bloc_name;
        $this->end_bloc_tmp[$id_bloc]["subject"] = $bloc_parsed;
       }
     else
      {
       $this->end_bloc_tmp[$id_bloc][$level-1]["motif"][] = "/<$cur_bloc_name>(.*)?<\\/$cur_bloc_name>/msU";
       $this->end_bloc_tmp[$id_bloc][$level-1]["replace"][] = $bloc_parsed;
      }

     //echo "$id_bloc $level $cur_bloc_name<br>\n";

     // les enfants du bloc
     if(@count($arr[$cur_bloc_name]["children"]) > 0)
       {$this->_AllWriteBloc($id_bloc,$level+1,$arr[$cur_bloc_name]["children"],$cur_bloc_name);}
     }

 }


// fonction
 function _AllBlocParsingProcess()
 {
   for($i=0;$i<@count($this->end_bloc_tmp);$i++)
   {
     $cur_tmp = $this->end_bloc_tmp[$i];
     $subject = $cur_tmp["subject"];
     $bloc_name = $cur_tmp["name"];

          for($j=0;$j<@count($cur_tmp)-2;$j++)   // on retire le name & le subject
          {
              $motif = $cur_tmp[$j]["motif"];
              $replace = $cur_tmp[$j]["replace"];
              $subject = $this->_ReplaceBloc($motif,$replace,$subject);
          }

     // on remplace le bloc parsed dans le $this->bloc
     $this->filebuffer = $this->_ReplaceBloc($bloc_name,$subject,$this->filebuffer);
   }
}


// fonction writebloc cre chez son pere
 function WriteBloc($path="")
 {
   if(empty($path) || ($path == "this"))
    {$path = $this->last_bloc_path;}

   $path = @explode(".",$path);
   if(@count($path) == 1)
   {return;}    // c'est un big father on sort

   // on met le contenu du fils parsed chez le pere
   $last_bloc_name = $path[@count($path)-1];
   $fathers = @array_slice($path,0,@count($path)-1); // tous les noms sauf le dernier

   // on atteint le niveau du bloc pour l'ecriture
   $ref = &$this->bloc;

   for($i=0;$i<@count($fathers);$i++)
    {
     // c'est le dernier pere
     if($i == @count($fathers) -1)
      {
        $father = &$ref[$fathers[$i]];
        $father_parsed = &$ref[$fathers[$i]]["parsed"];
      }

     $ref = &$ref[$fathers[$i]]["children"];

    }

   $father["parsed"] = $this->_ReplaceBloc($last_bloc_name,$ref["$last_bloc_name"]["parsed"],$father_parsed);
   unset($ref["$last_bloc_name"]["parsed"]);// on efface le parsed du fils utile pour les loop
   //$ref["$last_bloc_name"]["parsed"] = $ref["$last_bloc_name"]["structure"];
 }

// avant la sotie de bloc
 function _ParsingProcess()
 {
   $this->_AllWriteBloc();  // on obtiens les blocs
   $this->_AllBlocParsingProcess();  // on les assign aux peres
 }


// sortie du fichier en mmoire
 function Write()
 {
   if(@count($this->bloc) > 0) // y des bloc ?
    {
     $this->_ParsingProcess();
    }

   $this->_ParseChrono();
   $this->_ParseLogo();

   echo $this->filebuffer;
   $this->_CreateCache(TPLN_CACHE_DIR."$this->file");
 }


// sortie du fichier en mmoire
// le place dans une variable
 function Output()
 {
   if(@count($this->bloc) > 0) // y des bloc ?
    {
     $this->_ParsingProcess();
    }

   $this->_ParseChrono();
   $this->_ParseLogo();

   $this->_CreateCache(TPLN_CACHE_DIR."$this->file");

   return $this->filebuffer;


 }

// logo
function AddLogo()
 {
  $this->add_logo = 1;
 }

function _ParseLogo()
{
    if($this->add_logo == 1) // on place le logo
    {
     $this->Parse("logo","<a href=\"http://tpln.sourceforge.net\"><img src=\"".TPLN_PATH."logo.gif\" border=\"0\" width=\"83\" height=\"33\" alt=\"Visit HomePage\"></a>");
    }
}



// chrono
function AddChrono($type="this")
 {
  $this->add_chrono = 1;
  $this->chrono_type = $type;
 }

function _ParseChrono()
{
    if($this->add_chrono == 1) // on place le chrono
    {
     $this->_GetExecutionTime();
     $this->Parse("chrono",$this->execution_time);
    }
}

// gestion du chrono
function _GetExecutionTime()
{
 $time = explode(' ',microtime());
 $fin = $time[1] + $time[0];

 // on veut les perf de cette session ou tous
 if($this->chrono_type == "this")
  {$this->execution_time = intval(10000 * ((double)$fin - (double)$this->chrono_started)) / 10000;}
 if($this->chrono_type == "ALL")
  {$this->execution_time = intval(10000 * ((double)$fin - (double)TPLN_CHRONO_STARTED)) / 10000;}

 $this->execution_time;
}

// Gestiond des erreurs
 function _Error($err_no,$item="",$bloc="")
 {
  switch($err_no)
    {
        // 0 pas de fichier trouv
         case 0:
             $err_msg = "File $this->file not found";
         break;

         // 1 item non trouv
         case 1 :
             $err_msg = "Item $item not found in $this->file";
         break;

         // 2 bloc inexistant
         case 2:
             $err_msg = "Bloc $bloc not found in $this->file";
         break;

        // 3 bloc inexistant dans un bloc
         case 3:
             $err_msg = "Bloc $bloc not found in Bloc $item $this->file";
         break;

        // 4 chemin du bloc error
        case 4:
             $err_msg = "Bloc path $item in $this->file";
         break;

        // 5 define a bloc
        case 5:
             $err_msg = "<B>Error $err_no :</B> Can't define an empty bloc";
         break;

        // 6 define an item
        case 6:
             $err_msg = "Can't define an empty item";
         break;

    }

    echo "<B>Error $err_no :</B> $err_msg";
    exit();
 }

/************* Cache ************/
// retourne la valeur de la premire ligne
function _InCachePeriod($file)
{
  $expire = $this->_GetTime($file);

  if($expire >= $this->time_started)
   {return 1;}
  else
   {return 0;}
}

// prend le temps au dessus du fichier
function _GetTime($file)
{
 $fp = @fopen($file, "r");// ouvre le fichier
 $expire = trim(fgets($fp,12));
 //$data = fread($fp, filesize($file));
 @fclose($fp);

 clearstatcache();

 return $expire;
}

function _CreateCache($file)
{
 if(!$this->add_cached_file)
  {
   return;
  }
 else
  {
   $cache_file_content = "$this->cache_expire\r$this->filebuffer";

   $fp = @fopen($file, "w"); // ouverture du fichier
   $this->filebuffer = @fwrite($fp,$cache_file_content);
   @fclose($fp);
   clearstatcache(); // efface la mmoire tampon
  }
}


}





?>
